/*
    The DataBox Libary - developerfriendly working with bytes
    Copyright (C) 2000-2001  Christian Leber

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail: c_l@bigfoot.com
*/

#ifndef PLIBS_DATABOX_BASE64_H_
#define PLIBS_DATABOX_BASE64_H_

#include "databox_core.h"

/* DATABOX TO BASE64 (*CHAR) */
/***********************************************************/
/* 
   read the *input DataBox and return and pointer to an
   malloced memory area with the content of DataBox base64
   encoded

   Returnvalue:
   NULL  = error, nothing changed 
   !NULL = pointer to memory area with the base64 encoded
           content of the input DataBox
*/
char *
DataBox_DataBox_to_base64(DataBox *input);


/* BASE64 (*CHAR) TO DATABOX */
/***********************************************************/
/* 
   read the base64 message in *input and DataBox decodes it
   to the *putput DataBox
   
   Returnvalue:
    0 = all went ok
   -1 = error, nothing changed
*/
int
DataBox_base64_to_DataBox(DataBox *output, char *input);

#endif /* PLIBS_DATABOX_BASE64_H_ */
