/*
    The DataBox Libary - developerfriendly working with bytes
    Copyright (C) 2000-2001  Christian Leber

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail: c_l@bigfoot.com
*/

#ifndef PLIBS_DATABOX_CRC_H_
#define PLIBS_DATABOX_CRC_H_

#include "databox_core.h"

/* ADD CRC32 CHECKSUM */
/***********************************************************/
/* 
   calculate and append a crc32 checksum to the *thisb DataBox
   
   Returnvalue:
    0 = ok 
   -1 = error
*/
int
DataBox_crc32_add(DataBox *thisb)
;


/* CHECK AND REMOVE CRC32 CHECKSUM */
/***********************************************************/
/* 
   check if the crc32 checksum is ok and remove it if is ok
   
   Returnvalue:
    0 = ok 
   -1 = error
   -2 = checksum not correct, nothing changed
*/
int
DataBox_crc32_checkandremove(DataBox *thisb)
;


#endif /* PLIBS_DATABOX_CRC_H_ */
