/*
    databox_crypto_blowfish.h - simple to use blowfish crypto functions
    Copyright (C) 2000-2001  Christian Leber

    This file is part of the DataBox crypto libary.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail: christian@leber.de
*/

#ifndef PLIBS_DATABOX_CRYPTO_BLOWFISH_H_
#define PLIBS_DATABOX_CRYPTO_BLOWFISH_H_

#include <time.h>
#include "blowfish.h"
#include "../databox/databox_core.h"

typedef struct {
	int init;
	plibs_u8 *blowfish_key;
	plibs_u32 blowfish_length;
	int sched_init;
	BLOWFISH_context *sched;
	} DataBoxBLOWFISH;

//struct DataBoxBLOWFISH_schedule {
//	WORD32 data[1042];
//	};	

DataBoxBLOWFISH *DataBox_blowfish_init(void);
int DataBox_blowfish_keygen(DataBoxBLOWFISH *input, int length);
int DataBox_blowfish_schedule(DataBoxBLOWFISH *input);

int DataBox_blowfish_encrypt(DataBox *input, DataBoxBLOWFISH *input_key);
int DataBox_blowfish_decrypt(DataBox *input, DataBoxBLOWFISH *input_key);

int DataBox_DataBoxBLOWFISH_to_DataBox(DataBox *output, DataBoxBLOWFISH *input);
int DataBox_DataBox_to_DataBoxBLOWFISH(DataBoxBLOWFISH *output, DataBox *input);

#endif /* PLIBS_DATABOX_CRYPTO_BLOWFISH_H_ */

