#ifndef PLIBS_DATABOX_CRYPTO_RSA_H_
#define PLIBS_DATABOX_CRYPTO_RSA_H_

#include "../databox/databox_core.h"

/* just includes gmp.h */
#include "../config/zy_gmp.h"

/* #######  RSA  ####### */

typedef struct {mpz_t e,n;} clrsa_public;
typedef struct {mpz_t d,n;} clrsa_privat;

typedef struct {
	int init;
	mpz_t e;
	mpz_t n;
	} DataBoxRSA_public;

typedef struct {
	int init;
	mpz_t d;
	mpz_t n;
	} DataBoxRSA_privat;

typedef struct {
	int init;
	/* for private and public key */
	mpz_t n;
	/* if mode is:
	 * 1  then it is a public key
	 * 2  then it is a privat key */
	int mode; 
	/* only for the public key */
	mpz_t e;
	/* only for the private key */
	mpz_t d;
	} DataBoxRSA;
/*
 * Nice to have:
 * -loading rsa key from file
 * -encrypt
 * -decrypt
 * -sign
 */


int DataBox_rsa2_encrypt(DataBox *workwith, DataBoxRSA *input_key);
int DataBox_rsa2_decrypt(DataBox *workwith, DataBoxRSA *input_key);


/* old */
int DataBox_rsa_encrypt(DataBox *workwith, clrsa_public *input_key);
int DataBox_rsa_decrypt(DataBox *workwith, clrsa_privat *input_key);

#endif /* PLIBS_DATABOX_CRYPTO_RSA_H_ */
