/*
    databox_hash.h - hash functionses for the DataBox libary
    Copyright (C) 2000-2001  Christian Leber

    This file is part of the DataBox crypto libary.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail: c_l@bigfoot.com
*/

#ifndef PLIBS_DATABOX_HASH_H_
#define PLIBS_DATABOX_HASH_H_

#include "../databox/databox_core.h"

/* CREATE MD5 HASH FOR DATABOX */
/***********************************************************/
/* 
   reads *input and creates an MD5 HASH in *md5_output
   the size of the output is 16 byte
   
   *input       will stay untouched
   *md5_output  will be destroyed, and filled up with the MD5
   
   if *input is empty an error (-1) will be returned 
   
   Returnvalue:
    0 = all went ok
   -1 = error
*/
int
DataBox_hash_md5_normal(DataBox *md5_output, DataBox *input);

#endif /* PLIBS_DATABOX_MPZ_H_ */
