#include <stdio.h>
#include <string.h>
#include "databox/databox.h"
/*
BUGS:
-no error checking
*/

int main()
{
	DataBox *DB1=NULL;
	DataBox *DB2=NULL;
	char *test1;

	DB1 = DataBox_init(0);

	test1 = (char *)strdup("Hallo, dies ist ein test!\0");
	printf("Message: %s\n",test1);

	if(DataBox_ucharstr_to_DataBox(DB1,test1) < 0)
	{
		printf("Error in DataBox_ucharstr_to_DataBox\n");
		exit(1);
	}

	printf("without crc32:\n");
	DataBox_hexdump(DB1);
	DataBox_crc32_add(DB1);
	printf("with crc32:\n");
	DataBox_hexdump(DB1);

	/* now lets make a copy to corrupt it :) */
	DB2 = DataBox_init(0);
	DataBox_copy(DB2,DB1);

	printf("test and remove crc32:\n");
	if(DataBox_crc32_checkandremove(DB1) == 0)
		printf("crc32 checksum correct\n");
	else
		printf("crc32 checksum __NOT__ correct\n");
	
	printf("now the copy:\n");
	DataBox_hexdump(DB2);
	printf("corrupted:\n");
	DB2->data[11]=23;
	DataBox_hexdump(DB2);
	
	printf("test and remove crc32:\n");
	if(DataBox_crc32_checkandremove(DB2) == 0)
		printf("crc32 checksum correct\n");
	else
		printf("crc32 checksum __NOT__ correct\n");
	
	/* tidy up */
	free(test1);
	DataBox_destroy(DB1);
	DataBox_destroy(DB2);
	exit(0);
}
