/* Cover function for malloc().  Returns a good pointer,
 * or else the function prints a message and exits the program.
 */

#include <stdlib.h>

void *
plibs_malloc(size_t size)
{
	void *ptr = malloc(size);
 
	if( ptr == NULL )
	{
		printf("Out of memory getting %lu bytes.  Program exiting.",(unsigned long)size );
		exit(1);
	}
	return ptr;
}


void *
plibs_realloc(void *input, size_t size)
{
	void *ptr = realloc(input,size);
 
	if( ptr == NULL )
	{
		printf("Out of memory getting %lu bytes.  Program exiting.",(unsigned long)size );
		exit(1);
	}
	return ptr;
}


void
plibs_free(void *input)
{
	free(input);
}
 
