#ifndef __cmdarg__
#define __cmdarg__
/*****
  command line parser interface -- generated by clig 
  (http://wsd.iitb.fhg.de/~kir/clighome/)

  The command line parser `clig':
  (C) 1995---2001 Harald Kirsch (kirschh@lionbioscience.com)
*****/

typedef struct s_Cmdline {
  /***** --version: give back the version */
  char versionP;
  /***** -h: help */
  char helpP;
  /***** --help: help */
  char helplongP;
  /***** --debug_to_file: write some stuff to coridoras.log */
  char debug_to_fileP;
  /***** -s: The IRC Server you wish to connect */
  char serverP;
  char* server;
  int serverC;
  /***** -kd: The directory that contains the PRIVAT directory with your privat key(s), default is $HOME/.coridoras */
  char key_directoryP;
  char* key_directory;
  int key_directoryC;
  /***** -sp: if you would like to use another port on the server then 6667 */
  char server_portP;
  long server_port;
  int server_portC;
  /***** -p: local port to connect to coridoras (default: 5667) */
  char portP;
  int port;
  int portC;
  /***** uninterpreted command line parameters */
  int argc;
  /*@null*/char **argv;
  /***** the whole command line concatenated */
  char *tool;
} Cmdline;


extern char *Program;
extern void usage(void);
extern /*@shared*/Cmdline *parseCmdline(int argc, char **argv);

#endif

